"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lambda = void 0;
let cachedApp;
const bootstrap = (module, opts) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const { NestFactory } = yield Promise.resolve().then(() => require('@nestjs/core'));
    if ((opts === null || opts === void 0 ? void 0 : opts.engine) === 'express') {
        let app = yield NestFactory.create(module);
        yield app.init();
        return app;
    }
    else if ((opts === null || opts === void 0 ? void 0 : opts.engine) === 'fastify') {
        const { FastifyAdapter } = yield Promise.resolve().then(() => require('@nestjs/platform-fastify'));
        let app = yield NestFactory.create(module, new FastifyAdapter((_a = opts === null || opts === void 0 ? void 0 : opts.fastify) === null || _a === void 0 ? void 0 : _a.options));
        yield app.init();
        const instance = app.getHttpAdapter().getInstance();
        yield instance.ready();
        return app;
    }
});
const handleAPIGatewayProxyEvent = (app, event, context, opts) => __awaiter(void 0, void 0, void 0, function* () {
    var _b;
    if ((opts === null || opts === void 0 ? void 0 : opts.engine) === 'fastify') {
        const { proxy } = yield Promise.resolve().then(() => require('aws-serverless-fastify'));
        return yield proxy(app.getHttpAdapter().getInstance(), event, context, ((_b = opts === null || opts === void 0 ? void 0 : opts.fastify) === null || _b === void 0 ? void 0 : _b.binaryTypes) || []);
    }
    else {
        const { proxy, createServer } = yield Promise.resolve().then(() => require('aws-serverless-express'));
        return proxy(createServer(app.getHttpAdapter().getInstance()), event, context, 'PROMISE').promise;
    }
});
exports.lambda = (module, opts) => {
    opts = opts ? opts : { engine: 'express' };
    if (opts.fastify) {
        opts.fastify.binaryTypes = opts.fastify.binaryTypes || [];
    }
    return (event, context) => __awaiter(void 0, void 0, void 0, function* () {
        var _a;
        try {
            if ((event === null || event === void 0 ? void 0 : event.source) && (event === null || event === void 0 ? void 0 : event.source) === ((_a = opts === null || opts === void 0 ? void 0 : opts.warmup) === null || _a === void 0 ? void 0 : _a.source))
                return 'Lambda is warm!';
            if (event === null || event === void 0 ? void 0 : event.httpMethod) {
                if (!cachedApp) {
                    cachedApp = yield bootstrap(module, opts);
                }
                return handleAPIGatewayProxyEvent(cachedApp, event, context, opts);
            }
        }
        catch (err) {
            console.error('Couldn\'t start server', err);
        }
    });
};
//# sourceMappingURL=index.js.map